diff -r 6dfa9313d1ba src/main/gov/nasa/jpf/jvm/bytecode/INVOKEDYNAMIC.java
--- a/src/main/gov/nasa/jpf/jvm/bytecode/INVOKEDYNAMIC.java	Fri Oct 24 22:52:39 2014 -0700
+++ b/src/main/gov/nasa/jpf/jvm/bytecode/INVOKEDYNAMIC.java	Thu Jan 22 21:38:09 2015 -0500
@@ -20,6 +20,7 @@
 
 import gov.nasa.jpf.vm.BootstrapMethodInfo;
 import gov.nasa.jpf.vm.ClassInfo;
+import gov.nasa.jpf.vm.ElementInfo;
 import gov.nasa.jpf.vm.FunctionObjectFactory;
 import gov.nasa.jpf.vm.Instruction;
 import gov.nasa.jpf.vm.LoadOnJPFRequired;
@@ -54,6 +55,8 @@
   
   int funcObjRef = MJIEnv.NULL;
   
+  ElementInfo lastFuncObj = null;
+  
   public INVOKEDYNAMIC () {}
 
   protected INVOKEDYNAMIC (int bmIndex, String methodName, String descriptor){
@@ -89,7 +92,9 @@
   public Instruction execute (ThreadInfo ti) {
     StackFrame frame = ti.getModifiableTopFrame();
     
-    if(funcObjRef == MJIEnv.NULL) {
+    ElementInfo ei = ti.getHeap().get(funcObjRef);
+    
+    if(ei==null || ei!=lastFuncObj) {
       ClassInfo fiClassInfo;
 
       // First, resolve the functional interface
@@ -118,6 +123,7 @@
       Object[] freeVariableValues = frame.getArgumentsValues(ti, freeVariableTypes);
       
       funcObjRef = funcObjFactory.getFunctionObject(ti, fiClassInfo, samUniqueName, bmi, freeVariableTypeNames, freeVariableValues);
+      lastFuncObj = ti.getHeap().get(funcObjRef);
     }
     
     frame.pop(freeVariableTypes.length);
